<!DOCTYPE html>
<!-- Generated by pkgdown: do not edit by hand --><html lang="en">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
<title>RDB analysis report published to https://report.rdb.vote • rdb.report</title>
<script src="lightswitch.js"></script><script src="deps/jquery-3.6.0/jquery-3.6.0.min.js"></script><meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
<link href="deps/bootstrap-5.3.1/bootstrap.min.css" rel="stylesheet">
<script src="deps/bootstrap-5.3.1/bootstrap.bundle.min.js"></script><link href="deps/font-awesome-6.5.2/css/all.min.css" rel="stylesheet">
<link href="deps/font-awesome-6.5.2/css/v4-shims.min.css" rel="stylesheet">
<script src="deps/headroom-0.11.0/headroom.min.js"></script><script src="deps/headroom-0.11.0/jQuery.headroom.min.js"></script><script src="deps/bootstrap-toc-1.0.1/bootstrap-toc.min.js"></script><script src="deps/clipboard.js-2.0.11/clipboard.min.js"></script><script src="deps/search-1.0.0/autocomplete.jquery.min.js"></script><script src="deps/search-1.0.0/fuse.min.js"></script><script src="deps/search-1.0.0/mark.min.js"></script><!-- pkgdown --><script src="pkgdown.js"></script><meta property="og:title" content="RDB analysis report published to https://report.rdb.vote">
<meta name="description" content="Sources of the continuously updated Referendum Database (RDB) report.">
<meta property="og:description" content="Sources of the continuously updated Referendum Database (RDB) report.">
<meta name="twitter:card" content="summary">
<meta name="twitter:creator" content="@2BSalim">
<meta name="twitter:site" content="@2BSalim">
<meta name="robots" content="noindex">
<script src="https://rpkg.dev/counter-dev.min.js" data-id="4c4963fe-9fcf-4d81-95bb-2135e114b85b" data-utcoffset="1"></script>
</head>
<body>
    <a href="#main" class="visually-hidden-focusable">Skip to contents</a>


    <nav class="navbar navbar-expand-lg fixed-top " aria-label="Site navigation"><div class="container">

    <a class="navbar-brand me-2" href="index.html">rdb.report</a>

    <small class="nav-text text-danger me-auto" data-bs-toggle="tooltip" data-bs-placement="bottom" title="In-development version">0.0.9016</small>


    <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbar" aria-controls="navbar" aria-expanded="false" aria-label="Toggle navigation">
      <span class="navbar-toggler-icon"></span>
    </button>

    <div id="navbar" class="collapse navbar-collapse ms-3">
      <ul class="navbar-nav me-auto">
<li class="nav-item"><a class="nav-link" href="articles/rdb-report.html">Get started</a></li>
<li class="nav-item"><a class="nav-link" href="reference/index.html">Reference</a></li>
      </ul>
<ul class="navbar-nav">
<li class="nav-item"><form class="form-inline" role="search">
 <input class="form-control" type="search" name="search-input" id="search-input" autocomplete="off" aria-label="Search site" placeholder="Search for" data-search-index="search.json">
</form></li>
<li class="nav-item"><a class="external-link nav-link" href="https://gitlab.com/zdaarau/rpkgs/rdb.report/" aria-label="GitLab"><span class="fa fab fa-gitlab fa-lg"></span></a></li>
<li class="nav-item dropdown">
  <button class="nav-link dropdown-toggle" type="button" id="dropdown-lightswitch" data-bs-toggle="dropdown" aria-expanded="false" aria-haspopup="true" aria-label="Light switch"><span class="fa fa-sun"></span></button>
  <ul class="dropdown-menu dropdown-menu-end" aria-labelledby="dropdown-lightswitch">
<li><button class="dropdown-item" data-bs-theme-value="light"><span class="fa fa-sun"></span> Light</button></li>
    <li><button class="dropdown-item" data-bs-theme-value="dark"><span class="fa fa-moon"></span> Dark</button></li>
    <li><button class="dropdown-item" data-bs-theme-value="auto"><span class="fa fa-adjust"></span> Auto</button></li>
  </ul>
</li>
      </ul>
</div>


  </div>
</nav><div class="container template-home">
<div class="row">
  <main id="main" class="col-md-9"><div class="section level1">
<div class="page-header"><h1 id="rdbreport">rdb.report<a class="anchor" aria-label="anchor" href="#rdbreport"></a>
</h1></div>
<p><a href="https://app.netlify.com/sites/report-rdb-vote/deploys" class="external-link"><img src="https://api.netlify.com/api/v1/badges/c12b99ba-78ba-45bd-aebd-508b28e20305/deploy-status" alt="Netlify Status"></a></p>
<p>Sources of the continuously updated <a href="https://report.rdb.vote/" class="external-link">Referendum Database (RDB) report</a>.</p>
<div class="section level2">
<h2 id="get-started">Get started<a class="anchor" aria-label="anchor" href="#get-started"></a>
</h2>
<p>Instructions on how to comment and work on the report are found <a href="articles/rdb-report.html">here</a>.</p>
</div>
<div class="section level2">
<h2 id="package-documentation">Package documentation<a class="anchor" aria-label="anchor" href="#package-documentation"></a>
</h2>
<p>Formal documentation of this package is found <a href="https://rdb.report.rpkg.dev/reference">here</a>.</p>
</div>
<div class="section level2">
<h2 id="package-installation">Package installation<a class="anchor" aria-label="anchor" href="#package-installation"></a>
</h2>
<p>To install the latest development version of rdb.report, run the following in R:</p>
<div class="sourceCode" id="cb1"><pre class="downlit sourceCode r">
<code class="sourceCode R"><span><span class="kw">if</span> <span class="op">(</span><span class="op">!</span><span class="op">(</span><span class="st">"remotes"</span> <span class="op"><a href="https://rdrr.io/r/base/match.html" class="external-link">%in%</a></span> <span class="fu"><a href="https://rdrr.io/r/base/colnames.html" class="external-link">rownames</a></span><span class="op">(</span><span class="fu"><a href="https://rdrr.io/r/utils/installed.packages.html" class="external-link">installed.packages</a></span><span class="op">(</span><span class="op">)</span><span class="op">)</span><span class="op">)</span><span class="op">)</span> <span class="op">{</span></span>
<span>  <span class="fu"><a href="https://rdrr.io/r/utils/install.packages.html" class="external-link">install.packages</a></span><span class="op">(</span>pkgs <span class="op">=</span> <span class="st">"remotes"</span>,</span>
<span>                   repos <span class="op">=</span> <span class="st">"https://cloud.r-project.org/"</span><span class="op">)</span></span>
<span><span class="op">}</span></span>
<span></span>
<span><span class="fu">remotes</span><span class="fu">::</span><span class="fu"><a href="https://remotes.r-lib.org/reference/install_gitlab.html" class="external-link">install_gitlab</a></span><span class="op">(</span>repo <span class="op">=</span> <span class="st">"zdaarau/rpkgs/rdb.report"</span><span class="op">)</span></span></code></pre></div>
</div>
<div class="section level2">
<h2 id="package-configuration">Package configuration<a class="anchor" aria-label="anchor" href="#package-configuration"></a>
</h2>
<p>Some of rdb.report’s functionality is controlled via package-specific global configuration which can either be set via <a href="https://rdrr.io/r/base/options.html" class="external-link">R options</a> or <a href="https://en.wikipedia.org/wiki/Environment_variable" class="external-link">environment variables</a> (the former take precedence). This configuration includes:</p>
<div class="table-wide">
<table class="table">
<thead><tr>
<th align="left"><strong>Description</strong></th>
<th align="left"><strong>R option</strong></th>
<th align="left"><strong>Environment variable</strong></th>
<th align="left"><strong>Default value</strong></th>
</tr></thead>
<tbody><tr>
<td align="left">Maximal timespan to preserve the package’s <a href="https://pkgpins.rpkg.dev/" class="external-link">pkgpins</a> cache. Cache entries older than this will be deleted upon package loading.</td>
<td align="left"><code>rdb.report.global_max_cache_age</code></td>
<td align="left"><code>R_RDB_REPORT_GLOBAL_MAX_CACHE_AGE</code></td>
<td align="left"><code>"30 days"</code></td>
</tr></tbody>
</table>
</div>
</div>
<div class="section level2">
<h2 id="package-development">Package development<a class="anchor" aria-label="anchor" href="#package-development"></a>
</h2>
<div class="section level3">
<h3 id="r-markdown-format">R Markdown format<a class="anchor" aria-label="anchor" href="#r-markdown-format"></a>
</h3>
<p>This package’s source code is written in the <a href="https://rmarkdown.rstudio.com/" class="external-link">R Markdown</a> file format to facilitate practices commonly referred to as <a href="https://en.wikipedia.org/wiki/Literate_programming" class="external-link"><em>literate programming</em></a>. It allows the actual code to be freely mixed with explanatory and supplementary information in expressive Markdown format instead of having to rely on <a href="https://rstudio.github.io/r-manuals/r-lang/Parser.html#comments" class="external-link"><code>#</code> comments</a> only.</p>
<p>All the <code>.gen.R</code> suffixed R source code found under <a href="https://gitlab.com/zdaarau/rpkgs/rdb.report/-/tree/master/R/" class="external-link"><code>R/</code></a> is generated from the respective R Markdown counterparts under <a href="https://gitlab.com/zdaarau/rpkgs/rdb.report/-/tree/master/Rmd/" class="external-link"><code>Rmd/</code></a> using <a href="https://pkgpurl.rpkg.dev/dev/reference/purl_rmd.html" class="external-link"><code>pkgpurl::purl_rmd()</code></a><a class="footnote-ref" tabindex="0" data-bs-toggle="popover" data-bs-content='&lt;p&gt;The very idea to leverage the R Markdown format to author R packages was originally proposed by Yihui Xie. See his excellent &lt;a href="https://yihui.org/rlp/" class="external-link"&gt;blog post&lt;/a&gt; for his point of view on the advantages of literate programming techniques and some practical examples. Note that using &lt;code&gt;&lt;a href="https://pkgpurl.rpkg.dev/reference/purl_rmd.html" class="external-link"&gt;pkgpurl::purl_rmd()&lt;/a&gt;&lt;/code&gt; is a less cumbersome alternative to the Makefile approach outlined by him.&lt;/p&gt;'><sup>1</sup></a>. Always make changes only to the <code>.Rmd</code> files – never the <code>.R</code> files – and then run <code><a href="https://pkgpurl.rpkg.dev/reference/purl_rmd.html" class="external-link">pkgpurl::purl_rmd()</a></code> to regenerate the R source files.</p>
</div>
<div class="section level3">
<h3 id="coding-style">Coding style<a class="anchor" aria-label="anchor" href="#coding-style"></a>
</h3>
<p>This package borrows a lot of the <a href="https://www.tidyverse.org/" class="external-link">Tidyverse</a> design philosophies. The R code is guided by the <a href="https://design.tidyverse.org/" class="external-link">Tidy design principles</a> and is formatted according to the <a href="https://style.tidyverse.org/" class="external-link">Tidyverse Style Guide</a> (TSG) with the following exceptions:</p>
<ul>
<li>
<p>Line width is limited to <strong>160 characters</strong>, double the <a href="https://style.tidyverse.org/syntax.html#long-lines" class="external-link">limit proposed by the TSG</a> (80 characters is ridiculously little given today’s high-resolution wide screen monitors).</p>
<p>Furthermore, the preferred style for breaking long lines differs. Instead of wrapping directly after an expression’s opening bracket as <a href="https://style.tidyverse.org/syntax.html#long-lines" class="external-link">suggested by the TSG</a>, we prefer two fewer line breaks and indent subsequent lines within the expression by its opening bracket:</p>
<div class="sourceCode" id="cb2"><pre class="downlit sourceCode r">
<code class="sourceCode R"><span><span class="co"># TSG proposes this</span></span>
<span><span class="fu">do_something_very_complicated</span><span class="op">(</span></span>
<span>  something <span class="op">=</span> <span class="st">"that"</span>,</span>
<span>  requires <span class="op">=</span> <span class="va">many</span>,</span>
<span>  arguments <span class="op">=</span> <span class="st">"some of which may be long"</span></span>
<span><span class="op">)</span></span>
<span></span>
<span><span class="co"># we prefer this</span></span>
<span><span class="fu">do_something_very_complicated</span><span class="op">(</span>something <span class="op">=</span> <span class="st">"that"</span>,</span>
<span>                              requires <span class="op">=</span> <span class="va">many</span>,</span>
<span>                              arguments <span class="op">=</span> <span class="st">"some of which may be long"</span><span class="op">)</span></span></code></pre></div>
<p>This results in less vertical and more horizontal spread of the code and better readability in pipes.</p>
</li>
<li><p>Usage of <a href="https://magrittr.tidyverse.org/reference/compound.html" class="external-link">magrittr’s compound assignment pipe-operator <code>%&lt;&gt;%</code></a> is desirable<a class="footnote-ref" tabindex="0" data-bs-toggle="popover" data-bs-content='&lt;p&gt;The TSG &lt;a href="https://style.tidyverse.org/pipes.html#assignment-2" class="external-link"&gt;explicitly instructs to avoid this operator&lt;/a&gt; – presumably because it’s relatively unknown and therefore might be confused with the forward pipe operator &lt;code&gt;%&amp;gt;%&lt;/code&gt; when skimming code only briefly. I don’t consider this to be an actual issue since there aren’t many sensible usage patterns of &lt;code&gt;%&amp;gt;%&lt;/code&gt; at the beginning of a pipe sequence inside a function – I can only think of creating side effects and relying on &lt;a href="https://rdrr.io/r/base/function.html" class="external-link"&gt;R’s implicit return of the last evaluated expression&lt;/a&gt;. Therefore – and because I really like the &lt;code&gt;%&amp;lt;&amp;gt;%&lt;/code&gt; operator – it’s usage is welcome.&lt;/p&gt;'><sup>2</sup></a>.</p></li>
<li><p>Usage of <a href="https://rdrr.io/r/base/assignOps.html" class="external-link">R’s right-hand assignment operator <code>-&gt;</code></a> is not allowed<a class="footnote-ref" tabindex="0" data-bs-toggle="popover" data-bs-content='&lt;p&gt;The TSG &lt;a href="https://style.tidyverse.org/pipes.html#assignment-2" class="external-link"&gt;explicitly accepts &lt;code&gt;-&amp;gt;&lt;/code&gt; for assignments at the end of a pipe sequence&lt;/a&gt; while Google’s R Style Guide &lt;a href="https://google.github.io/styleguide/Rguide.html#right-hand-assignment" class="external-link"&gt;considers this bad practice&lt;/a&gt; because it “makes it harder to see in code where an object is defined”. I second the latter.&lt;/p&gt;'><sup>3</sup></a>.</p></li>
<li><p>R source code is <em>not</em> split over several files as <a href="https://style.tidyverse.org/package-files.html" class="external-link">suggested by the TSG</a> but instead is (as far as possible) kept in the single file <a href="https://gitlab.com/zdaarau/rpkgs/rdb.report/-/tree/master/Rmd/rdb.report.Rmd" class="external-link"><code>Rmd/rdb.report.Rmd</code></a> which is well-structured thanks to its <a href="#r-markdown-format">Markdown support</a>.</p></li>
</ul>
<p>As far as possible, these deviations from the TSG plus some additional restrictions are formally specified in <a href="https://pkgpurl.rpkg.dev/reference/default_linters" class="external-link"><code>pkgpurl::default_linters</code></a>, which is (by default) used in <a href="https://pkgpurl.rpkg.dev/reference/lint_rmd" class="external-link"><code>pkgpurl::lint_rmd()</code></a>, which in turn is the recommended way to lint this package.</p>
</div>
</div>
</div>


  </main><aside class="col-md-3"><div class="links">
<h2 data-toc-skip>Links</h2>
<ul class="list-unstyled">
<li><a href="https://gitlab.com/zdaarau/rpkgs/rdb.report/" class="external-link">Browse source code</a></li>
<li><a href="https://gitlab.com/zdaarau/rpkgs/rdb.report/-/issues" class="external-link">Report a bug</a></li>
</ul>
</div>

<div class="license">
<h2 data-toc-skip>License</h2>
<ul class="list-unstyled">
<li><a href="LICENSE.html">Full license</a></li>
<li><small>AGPL (&gt;= 3)</small></li>
</ul>
</div>


<div class="citation">
<h2 data-toc-skip>Citation</h2>
<ul class="list-unstyled">
<li><a href="authors.html#citation">Citing rdb.report</a></li>
</ul>
</div>

<div class="developers">
<h2 data-toc-skip>Developers</h2>
<ul class="list-unstyled">
<li>Salim Brüggemann <br><small class="roles"> Author, maintainer </small> <a href="https://orcid.org/0000-0002-5329-5987" target="orcid.widget" aria-label="ORCID" class="external-link"><span class="fab fa-orcid orcid" aria-hidden="true"></span></a> </li>
<li>Uwe Serdült <br><small class="roles"> Author </small> <a href="https://orcid.org/0000-0002-2383-3158" target="orcid.widget" aria-label="ORCID" class="external-link"><span class="fab fa-orcid orcid" aria-hidden="true"></span></a> </li>
<li><a href="authors.html">More about authors...</a></li>
</ul>
</div>



  </aside>
</div>


    <footer><div class="pkgdown-footer-left">
  <p>Developed by Salim Brüggemann, Uwe Serdült.</p>
</div>

<div class="pkgdown-footer-right">
  <p>Site built with <a href="https://pkgdown.r-lib.org/" class="external-link">pkgdown</a> 2.1.1.9000.</p>
</div>

    </footer>
</div>





  </body>
</html>
